var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import FingerprintJS from '@fingerprintjs/fingerprintjs-pro';
import Cookies from 'js-cookie';
var VERSION = "1.3.22";
var BASE_DOMAIN = "https://lap-api.com";
var VideoType;
(function (VideoType) {
    VideoType[VideoType["vast"] = 0] = "vast";
    VideoType[VideoType["vmap"] = 1] = "vmap";
})(VideoType || (VideoType = {}));
var CookiesNames;
(function (CookiesNames) {
    CookiesNames["UID"] = "lap_u";
    CookiesNames["VISITS"] = "lap_v";
    CookiesNames["BANNER_SIZES"] = "lap_b_s";
})(CookiesNames || (CookiesNames = {}));
var getPixels = function (size) { return size.toString() + "px"; };
function getUid() {
    return __awaiter(this, void 0, void 0, function () {
        var preUid, fpPromise, results, uid, e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    preUid = Cookies.get(CookiesNames.UID);
                    if (preUid) {
                        return [2 /*return*/, preUid];
                    }
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 4, , 5]);
                    return [4 /*yield*/, FingerprintJS.load({
                            apiKey: "vBo0DIT6ZcFq1VUX15y5",
                            region: "eu"
                        })];
                case 2:
                    fpPromise = _a.sent();
                    return [4 /*yield*/, fpPromise.get()];
                case 3:
                    results = _a.sent();
                    uid = results.visitorId;
                    Cookies.set(CookiesNames.UID, uid, {
                        expires: 99999,
                        path: '/'
                    });
                    return [2 /*return*/, uid];
                case 4:
                    e_1 = _a.sent();
                    console.error("Failed to get uid: ".concat(e_1));
                    return [2 /*return*/, null];
                case 5: return [2 /*return*/];
            }
        });
    });
}
function getBannerSizes() {
    return __awaiter(this, void 0, void 0, function () {
        var preSizes, response, sizes;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    preSizes = Cookies.get(CookiesNames.BANNER_SIZES);
                    if (preSizes) {
                        return [2 /*return*/, JSON.parse(preSizes)];
                    }
                    return [4 /*yield*/, fetch(getUrl("b", {}, "sizes"))];
                case 1:
                    response = _a.sent();
                    if (!response.ok) {
                        throw new Error("Failed to get banner sizes");
                    }
                    return [4 /*yield*/, response.json()];
                case 2:
                    sizes = _a.sent();
                    Cookies.set(CookiesNames.BANNER_SIZES, JSON.stringify(sizes), {
                        path: '/'
                    });
                    return [2 /*return*/, sizes];
            }
        });
    });
}
function getUrl(endpoint, params, path) {
    if (path === void 0) { path = ""; }
    return "".concat(BASE_DOMAIN, "/").concat(endpoint).concat(path == "" ? "" : "/" + path, "?").concat(new URLSearchParams(params).toString());
}
function checkForUpdate() {
    return __awaiter(this, void 0, void 0, function () {
        var response, settings, e_2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 3, , 4]);
                    return [4 /*yield*/, fetch(getUrl("settings", {}))];
                case 1:
                    response = _a.sent();
                    if (!response.ok) {
                        console.error("Failed to get update status");
                    }
                    return [4 /*yield*/, response.json()];
                case 2:
                    settings = _a.sent();
                    return [2 /*return*/, settings.library_version != VERSION ? settings.library_version : null];
                case 3:
                    e_2 = _a.sent();
                    console.error("Failed to get update status: ".concat(e_2));
                    return [2 /*return*/, null];
                case 4: return [2 /*return*/];
            }
        });
    });
}
function getAudioAdData(app, uid) {
    return __awaiter(this, void 0, void 0, function () {
        var response;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, fetch(getUrl("a", { app: app, uid: uid }))];
                case 1:
                    response = _a.sent();
                    if (!response.ok) {
                        throw new Error("Failed to get audio ad data");
                    }
                    else if (response.status == 204) {
                        return [2 /*return*/, null];
                    }
                    return [4 /*yield*/, response.json()];
                case 2: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
function getVideoAdUrl(app, uid, type) {
    return getUrl("v", { app: app, uid: uid }, type.toString());
}
function addClasses(element, classes, defaultClasses) {
    if (defaultClasses === void 0) { defaultClasses = ""; }
    if (typeof classes === "string") {
        element.className = defaultClasses + " " + classes;
    }
    else if (classes instanceof Array) {
        element.className = defaultClasses + " " + classes.join(" ");
    }
    else {
        element.className = defaultClasses;
    }
}
var LapB = /** @class */ (function () {
    function LapB(uid, app, element, autoRender, sizeId) {
        if (uid === void 0) { uid = "default-uid-web"; }
        if (app === void 0) { app = "default-app-web"; }
        if (element === void 0) { element = document.body; }
        var _this = this;
        this.uid = uid;
        this.app = app;
        this.element = element;
        this.autoRender = autoRender;
        this.sizeId = sizeId;
        getBannerSizes().then(function (sizes) {
            _this.bannerSize = sizes.find(function (size) { return size.id == sizeId; }) || sizes[0];
            if (_this.bannerSize) {
                _this.render();
            }
        });
    }
    LapB.init = function (uid, app) {
        if (uid === void 0) { uid = "default-uid-web"; }
        if (app === void 0) { app = "default-app-web"; }
        document.querySelectorAll("[data-lap-b]").forEach(function (element) {
            new LapB(uid, app, element, element.getAttribute("data-lap-b-render") === "auto", element.getAttribute("data-lap-b").toUpperCase() || "B");
        });
    };
    LapB.prototype.render = function () {
        this.iframe = document.createElement("iframe");
        this.iframe.src = getUrl("b", {
            app: this.app,
            uid: this.uid,
            size: this.sizeId,
            reload_auto: this.autoRender
        });
        this.iframe.style.border = "none";
        this.iframe.style.cursor = "pointer";
        this.iframe.style.width = getPixels(this.bannerSize.width);
        this.iframe.style.height = getPixels(this.bannerSize.height);
        this.element.appendChild(this.iframe);
        this.element.style.width = getPixels(this.bannerSize.width);
        this.element.style.height = getPixels(this.bannerSize.height);
        this.element.classList.add("lap-b-container");
        this.iframe.classList.add("lap-b-iframe");
    };
    return LapB;
}());
var LapN = /** @class */ (function () {
    function LapN(uid, app, element, nativeAdClasses) {
        if (uid === void 0) { uid = "default-uid-web"; }
        if (app === void 0) { app = "default-app-web"; }
        if (nativeAdClasses === void 0) { nativeAdClasses = {}; }
        this.impressed = false;
        this.uid = uid;
        this.app = app;
        this.element = element;
        this.impressed = false;
        this.render();
        // set this.classes based on element attributes, if provided
        this.classes = {
            container: this.element.getAttribute("data-lap-n-container") || nativeAdClasses.container || "",
            title: this.element.getAttribute("data-lap-n-title") || nativeAdClasses.title || "",
            content: this.element.getAttribute("data-lap-n-content") || nativeAdClasses.content || "",
            image: this.element.getAttribute("data-lap-n-image") || nativeAdClasses.image || "",
            textContainer: this.element.getAttribute("data-lap-n-text-container") || nativeAdClasses.textContainer || "",
        };
        this.scrollListener = this.scrollListener.bind(this);
    }
    LapN.init = function (uid, app, nativeAdClasses) {
        if (uid === void 0) { uid = "default-uid-web"; }
        if (app === void 0) { app = "default-app-web"; }
        document.querySelectorAll("[data-lap-n]").forEach(function (element) {
            new LapN(uid, app, element, nativeAdClasses);
        });
    };
    LapN.prototype.render = function () {
        return __awaiter(this, void 0, void 0, function () {
            var response, _a, textContainer, title, content, image;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, fetch(getUrl("n", { app: this.app, uid: this.uid }))];
                    case 1:
                        response = _b.sent();
                        _a = this;
                        return [4 /*yield*/, response.json()];
                    case 2:
                        _a.data = _b.sent();
                        textContainer = document.createElement("div");
                        addClasses(textContainer, this.classes.textContainer, "lap-n-text-container");
                        textContainer.style.direction = "rtl";
                        title = document.createElement("h4");
                        title.innerText = this.data.title;
                        addClasses(title, this.classes.title, "lap-n-title");
                        title.style.margin = "8px";
                        textContainer.appendChild(title);
                        if (this.data.content) {
                            content = document.createElement("p");
                            content.innerText = this.data.content;
                            addClasses(content, this.classes.content, "lap-n-content");
                            content.style.margin = "8px";
                            textContainer.appendChild(content);
                        }
                        image = document.createElement("img");
                        image.src = this.data.image_url;
                        addClasses(image, this.classes.image, "lap-n-image");
                        this.element.appendChild(textContainer);
                        this.element.appendChild(image);
                        this.element.addEventListener("click", function () { return window.open(_this.data.url, "_blank"); });
                        this.element.style.cursor = "pointer";
                        this.element.style.maxWidth = "90vw";
                        this.element.style.display = "flex";
                        this.element.style.flexDirection = "column";
                        addClasses(this.element, this.classes.container, "lap-n-container");
                        this.scrollListener();
                        document.addEventListener("scroll", this.scrollListener, { passive: true });
                        return [2 /*return*/];
                }
            });
        });
    };
    LapN.prototype.scrollListener = function () {
        var _a;
        if (this.impressed)
            return;
        if (this.element.getBoundingClientRect().top < window.innerHeight) {
            document.removeEventListener("scroll", this.scrollListener);
            this.impressed = true;
            fetch((_a = this.data) === null || _a === void 0 ? void 0 : _a.impression_url, { method: "POST" });
        }
    };
    return LapN;
}());
var LapI = /** @class */ (function () {
    function LapI(uid, app) {
        if (uid === void 0) { uid = "default-uid-web"; }
        if (app === void 0) { app = "default-app-web"; }
        this.uid = uid;
        this.app = app;
        this.render();
    }
    LapI.init = function (uid, app, visits) {
        if (uid === void 0) { uid = "default-uid-web"; }
        if (app === void 0) { app = "default-app-web"; }
        if (visits === void 0) { visits = 4; }
        if (visits == 0)
            return;
        var visitsCookie = Cookies.get(CookiesNames.VISITS);
        if (visitsCookie === undefined) {
            Cookies.set(CookiesNames.VISITS, "0");
        }
        else {
            var visitsNumber = parseInt(visitsCookie);
            if (visitsNumber >= visits) {
                new LapI(uid, app);
                Cookies.set(CookiesNames.VISITS, "0");
            }
            else {
                Cookies.set(CookiesNames.VISITS, String(visitsNumber + 1));
            }
        }
    };
    LapI.prototype.render = function () {
        var _this = this;
        this.div = document.createElement("div");
        this.div.style.position = "fixed";
        this.div.style.top = "0";
        this.div.style.left = "0";
        this.div.style.width = "100vw";
        this.div.style.height = "100vh";
        this.div.style.backgroundColor = "rgba(255,255,255,0)";
        // add blur effect
        // @ts-ignore
        this.div.style.backdropFilter = "blur(5px)";
        this.div.style.zIndex = "9999999";
        this.div.style.display = "flex";
        this.div.style.justifyContent = "center";
        this.div.style.alignItems = "center";
        this.div.style.transition = "opacity 0.5s ease-in-out";
        document.documentElement.appendChild(this.div);
        var iframe = document.createElement("iframe");
        iframe.src = getUrl("i", { app: this.app, uid: this.uid });
        iframe.style.border = "none";
        iframe.style.width = "100vw";
        iframe.style.height = "100vh";
        this.div.appendChild(iframe);
        var close = document.createElement("div");
        var cssText = "\n                position: absolute;\n                top: 0px;\n                right: 0px;\n                background: rgb(150, 150, 150);\n                color: white;\n                padding: 8px;\n                cursor: pointer;\n                z-index: 99999999;\n                border-radius: 100%;\n                border: 1px solid white;\n                margin: 16px;\n                transform: scale(1);\n                transition: transform 0.5s ease-in-out 0s;\n             \n                display: flex;\n                align-items: center;\n                justify-content: center;\n                           \n                display: flex;\n                align-items: center;\n                justify-content: center;\n            ".trim();
        close.innerHTML = "&#215;";
        var screenWidth = window.innerWidth;
        if (screenWidth > 800) {
            cssText += "\n                width: 2rem;\n                height: 2rem;\n                font-size: 2rem;\n            ".trim();
        }
        else {
            cssText += "\n               width: 1rem;\n               height: 1rem;\n               font-size: 2rem;\n            ".trim();
        }
        close.style.cssText = cssText;
        setTimeout(function () {
            close.style.transform = "scale(1)";
        }, 3000);
        close.addEventListener("click", function () { return _this.div.style.opacity = "0"; });
        // close.addEventListener("mouseenter", () => close.style.transform = "rotate(90deg)");
        // close.addEventListener("mouseleave", () => close.style.transform = "rotate(0deg)");
        this.div.addEventListener("transitionend", function (e) {
            if (e.propertyName === "opacity" && _this.div.style.opacity === "0") {
                document.documentElement.removeChild(_this.div);
            }
        });
        iframe.addEventListener("load", function () {
            _this.div.appendChild(close);
        });
    };
    return LapI;
}());
/**
 * Initialize the library.
 * @param app - The app name. You need to provide the exact same name that given to you by the Lap team.
 * @param options - The options object.
 */
export function init(app, options) {
    if (app === void 0) { app = "default-app-web"; }
    if (options === void 0) { options = {
        interstitialInterval: 4,
        nativeAdClasses: {}
    }; }
    return __awaiter(this, void 0, void 0, function () {
        var uid, needToUpdate;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getUid()];
                case 1:
                    uid = _a.sent();
                    return [4 /*yield*/, getBannerSizes()];
                case 2:
                    _a.sent();
                    LapB.init(uid, app);
                    LapI.init(uid, app, options.interstitialInterval);
                    LapN.init(uid, app, options.nativeAdClasses);
                    return [4 /*yield*/, checkForUpdate()];
                case 3:
                    needToUpdate = _a.sent();
                    console.log("%cLap initialized with version %c`".concat(VERSION, "` %con %c`").concat(app, "`."), "color: #a67a00; font-size: 14px; font-weight: bold;", "color: #fcba03; font-size: 14px; font-style: italic;", "color: #a67a00; font-size: 14px; font-weight: bold;", "color: #fcba03; font-size: 14px; font-style: italic;");
                    if (needToUpdate) {
                        console.log("%cLap %c`".concat(needToUpdate, "` %cis available, please update your library."), "color: #a67a00; font-size: 12px; font-weight: bold;", "color: #fcba03; font-size: 12px; font-style: italic;", "color: #a67a00; font-size: 12px; font-weight: bold;");
                    }
                    return [2 /*return*/, {
                            version: VERSION,
                            app: app,
                            getVideoAd: function (type) { return getVideoAd(type, app); },
                            getAudioAd: function () { return getAudioAd(app); },
                            getInterstitialAd: function () { return getInterstitialAd(app); },
                        }];
            }
        });
    });
}
export function getVideoAd(type, app) {
    if (type === void 0) { type = VideoType.vmap; }
    return __awaiter(this, void 0, void 0, function () {
        var uid;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!app) {
                        app = "default-app-web";
                        console.warn("No app specified, using default app");
                    }
                    return [4 /*yield*/, getUid()];
                case 1:
                    uid = _a.sent();
                    return [2 /*return*/, getVideoAdUrl(app, uid, type)];
            }
        });
    });
}
export function getAudioAd(app) {
    return __awaiter(this, void 0, void 0, function () {
        var uid;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!app) {
                        app = "default-app-web";
                        console.warn("No app specified, using default app");
                    }
                    return [4 /*yield*/, getUid()];
                case 1:
                    uid = _a.sent();
                    return [4 /*yield*/, getAudioAdData(app, uid)];
                case 2: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
export function getInterstitialAd(app) {
    return __awaiter(this, void 0, void 0, function () {
        var uid;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!app) {
                        app = "default-app-web";
                        console.warn("No app specified, using default app");
                    }
                    return [4 /*yield*/, getUid()];
                case 1:
                    uid = _a.sent();
                    new LapI(uid, app);
                    return [2 /*return*/];
            }
        });
    });
}
var lapObject = {
    version: VERSION,
    init: init,
    getVideoAd: getVideoAd,
    getAudioAd: getAudioAd,
    getInterstitialAd: getInterstitialAd,
};
export default lapObject;
//# sourceMappingURL=index.js.map